;; x, y, brightness
putpixel:
	push ebp
	mov ebp, esp

	push eax
	push ebx
	push ecx
	push edi

	; check pixel is in screen
	mov ebx, [ebp+12]	;y
	cmp ebx, [mbootinfo.fb_height]
	jge .done
	mov ecx, [ebp+8]	;x
	cmp ecx, [mbootinfo.fb_width]
	jge .done

	; Destination
	mov edi, [mbootinfo.fb_addr]
	mov eax, [mbootinfo.fb_pitch]
	mul dword ebx   ;y
	add edi, eax

	mov eax, ecx   ;x
	movzx ecx, byte [mbootinfo.fb_bytespp]
	mul ecx
	add edi, eax


	; Brightness
	mov eax, [ebp + 16]

	; Poke videomemory
	cld
	rep stosb
.done:
	pop edi
	pop ecx
	pop ebx
	pop eax

	pop ebp
	ret

; char, x, y
putchar:
	push ebp
	mov ebp, esp
	push eax
	push ebx
	push ecx
	push edx

	; skip non printable
	mov eax, [ebp+8] ;char
	cmp eax, 0x20
	jl .unprintable
	cmp eax, 0x7e
	jg .unprintable

	mov ecx, 16
	mul ecx
	mov esi, [kfont+eax]

	mov ebx, [ebp+12] ;x
	mov edx, [ebp+16] ;y

	cld
	xor eax, eax
.loop:
	lodsb	; load font row to al
	mov ah, 0
.loop2:
	shl al
	jnc .blankpix
	; draw a pixel
	push 0xff
	push edx ;x
	push ecx ;y
.blankpix:
	inc ah
	cmp ah, 8
	je .loop


.done:
	pop edx
	pop ecx
	pop ebx
	pop eax
	pop ebp
	ret
.unprintable:
	push .unprintablemsg
	call serialwrite
	add esp, 4
	jmp .done
.unprintablemsg: db 10,"Err: Unprintable char not handled!", 0

include "src/font.asm"
